/*
The direction class is a x, y coordinated vector taking the origin as reference

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.0 version.
Additional information is in API Reference in our web page.
*/

public class Direction
{
    protected double x,y;
    Direction(double parX, double parY){
        setDirection(parX,parY);
    }
    public void setDirection(double parX, double parY){
        double locSize=(Math.sqrt(Math.pow(parX, 2) +Math.pow(parY, 2)));
        x=(10*parX/locSize);
        y=(10*parY/locSize);        
    }
    public double getX(){
    	return x;
    }
    public double getY(){
    	return y;
    }
}