/*
The manager that manages the movements of the moving bricks in the game.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version, modified in the 1.3 version.
Additional information is in API Reference in our web page.
*/

import java.util.*;

public class MovingBrickManager extends ManagerTemplate
{
    MovingBrickManager(NormalLevel parLevel){
	  super(parLevel);
        waitTime=100;
    }
    public void run(){
        MovingBrick nextMvB;
	  Enumeration e;
	 try{	
        while(true){
            for ( e = ((NormalLevel)level).mvBricks.elements() ; e.hasMoreElements() ;) {
                nextMvB=((MovingBrick)e.nextElement());
                nextMvB.move();                
            }

                Th.sleep(waitTime);    
            level.ownerGame.notifyObserver();           
        	}
	 }catch(Exception ex){System.out.println("Error in moving brick control");}
    }
}