

// Importing from JDK


package cz99cps;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.sql.*;

// The main servlet class.
public class AvailableSlotsDBServlet extends HttpServlet {

    /**
     * service method
     */
    public void service(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {

      String CourseDescription;
      String Semester;
      String Year;
	Connection con;
	PrintStream out;

	// fetch the parameters
	CourseDescription = req.getParameter("CourseDescription");
	Semester = req.getParameter("Semester");
	Year = req.getParameter("Year");


/////////////

//////////////
	res.setContentType("text/html");
	out = new PrintStream(res.getOutputStream());
	printPageHeader(out, CourseDescription, Semester, Year);
//out.println(CourseDescription);

	// if no parameters, just print the form
	if (CourseDescription == null) {
	    printPageFooter(out);
	    return;
	}

	String url	 = "jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe";

//	out.println("<body bgcolor=\"#CC6600\" topmargin=\"0\" leftmargin=\"0\">");

	try {
	    // find the jdbc driver
		Class.forName("oracle.jdbc.driver.OracleDriver");

	    // get the connection to the database
	    con = DriverManager.getConnection(url, "cy99cps", "cy99cps");
//	    out.println("<hr>");
//	    out.println("<h3>JDBC Driver and Database Messages</h3>");
	    checkForWarning(con.getWarnings(), out);
	    DatabaseMetaData dma = con.getMetaData();
//	    out.println("Connected to " + dma.getURL() + "<br>");
//	    out.println("Driver       " + dma.getDriverName() + "<br>");
//	    out.println("Version      " + dma.getDriverVersion() + "<br>");

	    // create and execute the query
	    Statement stmt = con.createStatement();
	    ResultSet rs = stmt.executeQuery("Select * from cpsprojectsdemo where (cpscourse = " + CourseDescription + ") AND (Semester = '" + Semester + "') AND (Year = " + Year + ") AND (Available = 1) ORDER BY slotnumber");
//	    ResultSet rs = stmt.executeQuery("Select * from cpsprojectsdemo where (cpscourse = " + CourseDescription + ") AND (Semester = '" + Semester + "') AND (Year = " + Year + ") AND (Available = 1) ORDER BY DemoDate, DemoStarts, DemoFinishes");


	    // print out the result
	    dispResultSet(rs, out);
	    rs.close();
	    stmt.close();
	    con.close();
//	    out.println("<hr>");
	}
	catch (SQLException ex) {
	    out.println("<hr>*** SQLException caught ***<p>");
	    while (ex != null) {
	      out.println("SQLState: " + ex.getSQLState() + "<br>");
	      out.println("Message:  " + ex.getMessage() + "<br>");
	      out.println("Vendor:   " + ex.getErrorCode() + "<br>");
	      ex = ex.getNextException();
	    }
	}
	catch (java.lang.Exception ex) {
	    ex.printStackTrace();
	}

	printPageFooter(out);
    }

    /**
     * returns the servlet info
     */
    public String getServletInfo() {
	return "This is a simple servlet that shows how to use JDBC with servlets";
    }


    /*
     * check if the database server has anything to say
     */
    private void checkForWarning(SQLWarning warn, PrintStream out)
          throws SQLException
    {
       boolean rc = false;

       if (warn != null) {
          out.println("<hr>*** Warning ***<p>");
          rc = true;
          while (warn != null) {
             out.println("SQLState: " + warn.getSQLState() + "<br>");
             out.println("Message:  " + warn.getMessage() + "<br>");
             out.println("Vendor:   " + warn.getErrorCode() + "<br>");
             warn = warn.getNextWarning();
          }
       }
    }


    /*
     * display the result in html table format
     */
    private void dispResultSet(ResultSet rs, PrintStream out)
       throws SQLException
    {
            boolean goon = true;
        while (rs.next())
        {

//            try {
//                  rs.next();


out.println("  <option> On " + rs.getString(5) + " from " + rs.getString(6) + " to " +rs.getString(7) + " &nbsp &nbsp &nbsp &nbsp  Slot# " + rs.getString(1) + "</option>");


 //              }


 //           catch (Exception e) {
 //                     goon = false;
 //                     System.err.println("No more records");
//      e.printStackTrace();

            }


 //       }
 // }

/*

       int i;

       // metadata can supply information about the schema
       ResultSetMetaData rsmd = rs.getMetaData();
       int numCols = rsmd.getColumnCount();
       out.println("<hr>");
       out.println("<h3>Database Columns and Data</h3>");
       out.println("<table border=3>");
       out.println("<tr>");
       for (i=1; i<=numCols; i++) {
          out.println("<th>" + rsmd.getColumnLabel(i) + "</th>");
       }
       out.println("</tr>");

       // for entire data
//       while (rs.next()) {
	  out.println("<tr>");

	  // for one row
          for (i=1; i<=numCols; i++) {
	     dispElement(rs, rsmd.getColumnType(i), out, i);
          }
	  out.println("</tr>");
//       }
       out.println("</table>");
*/

    }


    // print one element
    private void dispElement(ResultSet rs, int dataType,
			     PrintStream out, int col)
          throws SQLException
    {

        // ask for data depending on the datatype
	switch(dataType) {
	case Types.DATE:
	  java.sql.Date date = rs.getDate(col);
	  out.println("<th>" + date.toString() + "</th>");
	  break;
	case Types.TIME:
	  java.sql.Time time = rs.getTime(col);
	  out.println("<th>" + time.toString() + "</th>");
	  break;
	case Types.TIMESTAMP:
	  java.sql.Timestamp timestamp = rs.getTimestamp(col);
	  out.println("<th>" + timestamp.toString() + "</th>");
	  break;
	case Types.CHAR:
	case Types.VARCHAR:
	case Types.LONGVARCHAR:
	  String str = rs.getString(col);
	  out.println("<th>" + str + "</th>");
	  break;
	case Types.NUMERIC:
	case Types.DECIMAL:
	  java.math.BigDecimal numeric = rs.getBigDecimal(col, 10);
	  out.println("<th>" + numeric.toString() + "</th>");
	  break;
	case Types.BIT:
	  boolean bit = rs.getBoolean(col);
	  out.println("<th>" + new Boolean(bit) + "</th>");
	  break;
	case Types.TINYINT:
	  byte tinyint = rs.getByte(col);
	  out.println("<th>" + new Integer(tinyint) + "</th>");
	  break;
	case Types.SMALLINT:
	  short smallint = rs.getShort(col);
	  out.println("<th>" + new Integer(smallint) + "</th>");
	  break;
	case Types.INTEGER:
	  int integer = rs.getInt(col);
	  out.println("<th>" + new Integer(integer) + "</th>");
	  break;
	case Types.BIGINT:
	  long bigint = rs.getLong(col);
	  out.println("<th>" + new Long(bigint) + "</th>");
	  break;
	case Types.REAL:
	  float real = rs.getFloat(col);
	  out.println("<th>" + new Float(real) + "</th>");
	  break;
	case Types.FLOAT:
	case Types.DOUBLE:
	  double longreal = rs.getDouble(col);
	  out.println("<th>" + new Double(longreal) + "</th>");
	  break;
	case Types.BINARY:
	case Types.VARBINARY:
	case Types.LONGVARBINARY:
	  byte[] binary = rs.getBytes(col);
	  out.println("<th>" + new String(binary, 0) + "</th>");
	  break;
	}
    }


    // Simple html header
    private void printPageHeader(PrintStream out, String CourseDescription, String Semester, String Year ) {
out.println("<html>");

out.println("<head>");
out.println("<meta http-equiv=\"Content-Type\" content=\"text/html  charset=windows-1252\">");
out.println("<meta http-equiv=\"Content-Language\" content=\"en-us\">");
out.println("<title>Slot Take</title>");



out.println("<meta name=\"GENERATOR\" content=\"Microsoft FrontPage 4.0\">");
out.println("<meta name=\"ProgId\" content=\"FrontPage.Editor.Document\">");
out.println("<meta name=\"Microsoft Theme\" content=\"copy-of-network-blitz-3 1011, default\">");
out.println("<meta name=\"Microsoft Border\" content=\"tl, default\">");

out.println("</head>");

out.println("<FORM ACTION=\"http://class-server.npac.syr.edu:61699/cps714summer99-servlets/cz99cps/TakeSlotDBServlet\" METHOD=\"GET\" >");

out.println("<body>");

out.println("<p align=\"center\"><font size=\"6\"><strong><img src=\"//carver.npac.syr.edu:3768/cps714summer99-docs/cz99cps/IS/Pickup.gif\" width=\"600\" height=\"60\" border=\"0\"></strong></font><br>");
            out.println("<p align=\"center\"><b>Here you will chose your preferred date &amp"); 
            out.println("time slot and fill the form to sign-up for your project demo.</b></p>");
            
      out.println("<hr>");
      out.println("<ul>");
        
          

          out.println("<li>");
            out.println("<p align=\"left\"><strong>Step 1 </strong>Select one date &amp  time slot from the");
            out.println("available ones and complete the remaining fields in the form. <i>If");
            out.println("you are working alone in your project, write your name in field");
            out.println("'Student 1 Name'.&nbsp  If you are working in group, write also your");
            out.println("fellow's names in fields 'Student 2 Name' (and 'Student 3 Name' if");
            out.println("necessary). You only sign-up once for the project, independently of");
            out.println("how many members you are.</i></p>");
            
out.println("        </li>");
        
          

out.println("          <li>");
            out.println("<p align=\"left\"><b>Step 2:</b>  Submit the entered information");
            out.println("by clicking in the Submit Selection button .</p>");
            
out.println("        </li>");
        
          

      out.println("</ul>");
    

      out.println("<hr>");
out.println("<p>&nbsp </p>");
out.println("<p align=\"left\"><b><font color=\"#000000\"><i>Time Slot Selection: </i> </font></b><!--webbot");
out.println("bot=\"Validation\" B-Disallow-First-Item=\"TRUE\" --><select size=\"1\" name=\"SelectedSlot\">");
  out.println("<option selected>Select one available date &amp  time slot</option>");

    }


    private void printPageFooter(PrintStream out) {

out.println("</select></p>");
out.println("<p align=\"left\"><b>Student 1 Name:&nbsp </b>&nbsp &nbsp  <input type=\"text\" name=\"Name1\" size=\"50\"></p>");
out.println("<p align=\"left\"><b>Student 2 Name:&nbsp </b>&nbsp &nbsp  <input type=\"text\" name=\"Name2\" size=\"50\"></p>");
out.println("<p align=\"left\"><b>Student 3 Name:</b>&nbsp &nbsp &nbsp  <input type=\"text\" name=\"Name3\" size=\"50\"></p>");
out.println("<p align=\"left\"><b>Project Title:&nbsp </b>&nbsp &nbsp &nbsp &nbsp &nbsp ");
out.println("<input type=\"text\" name=\"Title\" size=\"50\"></p>");
out.println("<p align=\"left\"><b>Comments:</b>&nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp ");
out.println("<input type=\"text\" name=\"Comments\" size=\"50\"></p>");
out.println("<hr>");
out.println("<p align=\"center\"><input type=\"submit\" value=\"Submit Selection\" name=\"Search\">&nbsp &nbsp &nbsp &nbsp &nbsp ");
out.println("<input type=\"reset\" value=\"Reset\" name=\"B2\"></p>");
out.println("<hr>");
out.println("<p><i>Problems when signing-up?&nbsp  e-mail:</i> <font color=\"#FF0000\"><a href=\"mailto:cgsarmor@mailbox.syr.edu\">cgsarmor@mailbox.syr.edu</a></font></p>");

out.println("<hr>");
out.println("<p>&nbsp </p>");

out.println("            &nbsp </body>");

out.println("</html>");

	out.flush();
    }
}

// end
// Christian Sarmoria
// cgsarmor@mailbox.syr.edu
