//package xml;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class xmlout extends HttpServlet {
//Initialize global variables
  myDatabase db = new myDatabase();

  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }
//Process the HTTP Get request

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    //command description
    String command = "null", user = "", style = "default", list = "all";
    personInfo pi = null ;
    String homeurl = "/xml";
    try {
      command = request.getParameter("command");
      list =  request.getParameter("list");
      user = request.getParameter("user");
      style =  request.getParameter("style");
      db.open();

      PrintWriter out = new PrintWriter (response.getOutputStream());

      if(command.equals("htmlinfo")) {
        response.setContentType("text/html");
        out.println("<html><head><title>info</title></head><body bgcolor=white>");
        pi = db.find( user );
        if(pi != null) {
          out.println("<br>User name: "+pi.getName());
          out.println("<br>User age: "+pi.getAge());
          out.println("<br>User occup: "+pi.getOccupation());
          out.println("<br>User style: "+pi.getStyle());
        } else
          out.println("<h1>User not found</h1>");
        out.println("</body></html>");
      } else if(command.equals("xmlinfo")) {
          response.setContentType("text/xml");
          String stylefile = "\"" + homeurl + "/" + style + ".xsl\"" ;
          out.println("<?xml:stylesheet type=\"text/xsl\" href="+ stylefile +" version=\"1.0\"?>");

          if( list.equals("all") ) user = "";
          String xmlstr = db.XMLfind( user );
          out.println(xmlstr);
      } else
        out.println("<error>User not found</error>");

      out.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
//Get Servlet information

  public String getServletInfo() {
    return "xml.xmlout Information";
  }
}

 