/*
A special type of ObjectTemplate that also has a type.

Copyright(c) Group Seven.
Added to the OO-Ball in the 1.2 version.
Additional information is in API Reference in our web page.
*/

import java.awt.*;

public abstract class TypedObject extends ObjectTemplate
{
    protected int type;
    
    TypedObject(int parX, int parY, Component parOwner, LevelTemplate parLevel){
        super(parX, parY, parOwner, parLevel);
    }
    
    TypedObject(int parX, int parY,Component parOwner, int parType,LevelTemplate parLevel){
        this(parX, parY, parOwner, parLevel);
        setType(parType);        
    }
    TypedObject(){
	super();
    }
    public int getType(){
        return type;
    }

   public void setType(int parType){
        type=parType;
    }
} 